/***
 * Excerpted from "The Agile Samurai",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/jtrap for more book information.
***/
using NUnit.Framework;
using src;

namespace test
{
    [TestFixture]
    public class DeckTest
    {
        [Test]
        public void Verify_deck_contains_52_cards()
        {
            var deck = new Deck();
            Assert.AreEqual(52, deck.Count());
        }

        [Test]
        public void Verify_deck_contains_thirteen_cards_for_each_suit()
        {
            var Deck = new Deck();
            Assert.AreEqual(13, Deck.NumberOfHearts());
            Assert.AreEqual(13, Deck.NumberOfClubs());
            Assert.AreEqual(13, Deck.NumberOfDiamonds());
            Assert.AreEqual(13, Deck.NumberOfSpades());
        }
    }

    [TestFixture]
    public class DeckTest2
    {
        [Test]
        public void Verify_deck_contains_52_cards()
        {
            var deck = new Deck();
            Assert.AreEqual(52, deck.Count());
        }

        [Test]
        public void Verify_deck_contains_thirteen_cards_for_each_suit()
        {
            var Deck = new Deck();
            Assert.AreEqual(13, Deck.NumberOfHearts());
            Assert.AreEqual(13, Deck.NumberOfClubs());
            Assert.AreEqual(13, Deck.NumberOfDiamonds());
            Assert.AreEqual(13, Deck.NumberOfSpades());
        }

        [Test]
        public void Verify_deck_contains_no_joker()
        {
            var Deck = new Deck();
            Assert.IsFalse(Deck.Contains(Card.JOKER));
        }

        [Test]
        public void Check_every_card_in_the_deck()
        {
            var Deck = new Deck();

            Assert.IsTrue(Deck.Contains(Card.TWO_OF_CLUBS));
            Assert.IsTrue(Deck.Contains(Card.TWO_OF_DIAMONDS));
            Assert.IsTrue(Deck.Contains(Card.TWO_OF_HEARTS));
            Assert.IsTrue(Deck.Contains(Card.TWO_OF_SPADES));

            Assert.IsTrue(Deck.Contains(Card.THREE_OF_CLUBS));
            Assert.IsTrue(Deck.Contains(Card.THREE_OF_DIAMONDS));
            Assert.IsTrue(Deck.Contains(Card.THREE_OF_HEARTS));
            Assert.IsTrue(Deck.Contains(Card.THREE_OF_SPADES));

            // the others
        }
    }
}